<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/html">
<head>
    <meta charset="UTF-8">
    <title>BärCODE Issuer</title>
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <link href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.6.0/css/bootstrap-reboot.css"
          rel="stylesheet">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css"
          integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.bundle.min.js"
            integrity="sha384-Piv4xVNRyMGpqkS2by6br4gNJ7DXjqk09RmUpJ8jgGtD7zP9yug3goQfGII0yAns"
            crossorigin="anonymous"></script>
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <style>
        main {
            margin-top: 100px;
            /*padding: 20px;*/
        }

        #ponc-form {
            max-width: 400px;
        }
    </style>
</head>
<body class="container">
<h1 id="header">BärCODE Issuer</h1>
<main class="row">
    <div class="col-lg-6 col-sm-12">
        <form id="ponc-form">
            <div class="form-group">
                <label for="first-name">First Name</label>
                <input type="text" id="first-name" class="form-control"/>
            </div>
            <div class="form-group">
                <label for="last-name">Last Name</label>
                <input type="text" id="last-name" class="form-control"/>
            </div>
            <div class="form-group">
                <label for="dob">Date Of Birth</label>
                <input type="date" placeholder="dd-mm-yyyy" id="dob" class="form-control"/>
            </div>
            <div class="form-group">
                <label for="procedure-time">Procedure Time</label>
                <input type="time" id="procedure-time" class="form-control"/>
            </div>
            <div class="form-group">
                <label for="procedure-day">Adjust procedure date</label>
                <input type="number" id="procedure-day" value="0" class="form-control"/>
            </div>
            <div class="form-group">
                <label for="procedure">Procedure</label>
                <select id="procedure" class="form-control">
                    <option value="1">Test: Antigen</option>
                    <option value="2">Test: PCR</option>
                    <option value="3">Vaccine: Corminaty</option>
                    <option value="4">Vaccine: Janssen</option>
                    <option value="5">Vaccine: Moderna</option>
                    <option value="6">Vaccine: Vaxzeria</option>
                </select>
            </div>
            <div id="second-procedure-group">
                <div class="form-group">
                    <label for="second-procedure-time">Procedure Time (Second procedure)</label>
                    <input type="time" id="second-procedure-time" class="form-control"/>
                </div>
                <div class="form-group">
                    <label for="second-procedure-day">Adjust procedure date (Second procedure)</label>
                    <input type="number" id="second-procedure-day" value="0" class="form-control"/>
                </div>
                <div class="form-group">
                    <label for="second-procedure">Procedure</label>
                    <select id="second-procedure" class="form-control">
                        <option value="1">Test: Antigen</option>
                        <option value="2">Test: PCR</option>
                        <option value="3">Vaccine: Corminaty</option>
                        <option value="4">Vaccine: Janssen</option>
                        <option value="5">Vaccine: Moderna</option>
                        <option value="6">Vaccine: Vaxzeria</option>
                    </select>
                </div>
            </div>
        </form>
        <button id="submit-button">SUBMIT</button>
    </div>
    <div class="col-lg-6 col-sm-12">
        <canvas id="ponc-canvas"></canvas>
        <img id="ponc-image" src="">
    </div>

</main>
<script>

    const singleUseProcedures = ["1", "2", "4"]
    const testProcedures = ["1", "2"]
    const secondForm = document.querySelector('#second-procedure-group');

    secondForm.style.display = "none";


    const procedureElement = document.querySelector('#procedure');
    procedureElement.addEventListener('change', (event) => {
        if (singleUseProcedures.includes(event.target.value)) {
            secondForm.style.display = "none";
        } else {
            secondForm.style.display = "block"
        }
    });

    formElem = document.getElementById("ponc-form")
    function submit(e) {
        e.preventDefault();
        let data = {};
        data.FirstName = document.getElementById("first-name").value;
        data.LastName = document.getElementById("last-name").value;
        data.DateOfBirth = new Date(document.getElementById("dob").value).toISOString();
        data.ProcedureResult = true;
        let procedureType = document.getElementById("procedure").value;

        if (testProcedures.includes(procedureType)) {
            data.ProcedureResult = false;
        }

        let pt = document.getElementById("procedure-time").value;
        pt = pt.split(":");
        let d = new Date();
        d.setHours(pt[0], pt[1]);

        let dayIncrement = parseInt(document.getElementById("procedure-day").value);
        d.setDate(d.getDate()+dayIncrement);
        let ProcedureTime = d.toISOString();

        data.Procedures = [
            {
                Type: parseInt(procedureType),
                Time: ProcedureTime,
            }
        ]

        if (!singleUseProcedures.includes(procedureType)) {
            let d2 = new Date();
            d2.setHours(pt[0], pt[1]);
            let day2Increment = parseInt(document.getElementById("second-procedure-day").value);
            d2.setDate(d2.getDate()+day2Increment);
            data.Procedures.push(
                {
                    Type: parseInt(document.getElementById("second-procedure").value),
                    Time: d2.toISOString(),
                }
            )
        }



        console.log(data);

        const Http = new XMLHttpRequest();
        const url = '/createCredential';
        Http.open("POST", url);
        Http.timeout =3000;
        Http.ontimeout = () => {
            console.log("timed out");
        };
        Http.send(JSON.stringify(data));

        Http.onreadystatechange = (e) => {
            if(Http.status === 200) {
                document.getElementById("ponc-image").src= "data:image/bmp;base64," + Http.responseText;
                // console.log(Http.responseText);
            }
        }
    }

    formElem.onsubmit = submit;
    document.getElementById("submit-button").onclick = submit;
</script>
</body>
</html>
